var Benchmark = require('benchmark');

var count = 1000;

var half = count/2;
var quat = count/4;

var arr1 = [];
var arr2 = new Array(count);

var count1, count2;

new Benchmark.Suite()
    .add('array pop/push', function() {
        var i;

        count1 = 0;

        for (i = 0; i < half; ++i) {
            arr1.push(i);
        }

        for (i = 0; i < quat; ++i) {
            count1 += arr1.pop();
        }

        for (i = 0; i < half; ++i) {
            arr1.push(i);
        }

        for (i = 0; i < quat; ++i) {
            count1 += arr1.pop();
        }

        for (i = 0; i < half; ++i) {
            arr1.push(i);
        }

        for (i = 0; i < quat; ++i) {
            count1 += arr1.pop();
        }
    })
    .add('array preallocation', function() {
        var i, index = 0;

        count2 = 0;

        for (i = 0; i < half; ++i) {
            arr2[index++] = i;
        }

        for (i = 0; i < quat; ++i) {
            count2 += arr2[--index];
        }

        for (i = 0; i < half; ++i) {
            arr2[index++] = i;
        }

        for (i = 0; i < quat; ++i) {
            count2 += arr2[--index];
        }

        for (i = 0; i < half; ++i) {
            arr2[index++] = i;
        }

        for (i = 0; i < quat; ++i) {
            count2 += arr2[--index];
        }
    })
    .on('complete', function() {
        console.log(this[0].toString(), count1);
        console.log(this[1].toString(), count2);

        console.log('Fastest is ' + this.filter('fastest').pluck('name'));
    })
    .on('error', function() {
        console.log(arguments);
    })
    .run();